package eforward.util;

import java.lang.reflect.*;
/**
 * Insert the type's description here.
 * Creation date: (05/13/02 5:20:21 pm)
 * @author: greg
 */
public class Proc {
	eforward.util.Mt iMt = null;
	eforward.util.Util iUtil = null;
	eforward.util.Txt tX = new eforward.util.Txt();
	int os = -1;
/**
 * Proc constructor comment.
 */
public Proc() {
	super();
	iUtil = new eforward.util.Util();
}
/**
 * Insert the method's description here.
 * Creation date: (09/24/16 11:21:22 am)
 * @param iMt eforward.util.Mt
 */
public Proc(Mt iMt) {
	this.iMt = iMt;
	iUtil = new eforward.util.Util();
}
/**
 * Insert the method's description here.
 * Creation date: (05/13/02 5:33:29 pm)
 * @param iUtil eforward.util.Util
 */
public Proc(Util iUtil) {
	this.iUtil = new eforward.util.Util();
}
/**
 * Insert the method's description here.
 * Creation date: (07/22/16 12:31:31 pm)
 * @param iUtil eforward.util.Util
 * @param os int
 */
public Proc(Util iUtil, int os) {
	this.iUtil = new eforward.util.Util();
	this.os = os;
}
/**
 * Insert the method's description here.
 * Creation date: (01/01/16 5:22:26 pm)
 * @return int
 */
public int getO() {
	if (java.io.File.separator.equals("/")) {
		// linux
		os = 1;
		return 1;
	}
	int typ = 0;
	Process c = null;
	java.io.InputStream in = null;
	java.io.ByteArrayOutputStream bo = null;
	try {
		String[] cmdl = {"cmd", "/C", "ver"};
		c = Runtime.getRuntime().exec(new eforward.util.Copy().arrayCopy(cmdl));
		in = c.getInputStream();
		int a;
		bo = new java.io.ByteArrayOutputStream();
		Thread.sleep(100);
		while ((a = in.read()) > -1) {
			bo.write(a);
		}
		byte[] ib = bo.toByteArray();
		bo.close();
		if (ib.length > 0) {
			String t = new String(ib);
			int k = t.indexOf("System/2");
			if (k > 0) {
				// os2
				typ = 2;
			} else {
				k = t.indexOf("Windows");
				if (k > 0) {
					// windows
					typ = 3;
				}
			}
		}
		c.waitFor();
		//System.gc();
	} catch (Exception e) {
	}
	try {
		if (in != null)
			in.close();
	} catch (Exception e) {
	}
	try {
		if (bo != null)
			bo.close();
	} catch (Exception e) {
	}
	try {
		if (c != null)
			c.destroy();
	} catch (Exception e) {
	}
	//System.out.println("typ:" +typ);		
	os = typ;
	return typ;
}
/**
 * Insert the method's description here.
 * Creation date: (11/04/00 8:45:54 am)
 * @return boolean
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param msg eforward.util.Emsg
 * @param verbose boolean
 */
public boolean runEfcBin(String proc, String fname, String iparm, Emsg msg, boolean verbose) {
	return runJ("efclient.bin." + proc, fname, iparm, msg, verbose);
}
/**
 * @return boolean
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param msg eforward.util.Emsg
 */
public boolean runEfcReceiverReq(String proc, String fname, String iparm, Emsg msg) {
	//runEfcbinr
	//boolean runEJprocR( String rproc, String fname, String iparm, Edirect.EdiSendEMsg eMsg )
	return runJ("efclient.receiver.req." + proc, fname, iparm, msg, false);
}
/**
 * @return boolean
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param msg eforward.util.Emsg
 */
public boolean runEfcSenderReq(String proc, String fname, String iparm, Emsg msg) {
	//runEfcbins
	//runEJprocS( String rproc, String fname, String iparm, Edirect.EdiSendEMsg eMsg )
	return runJ("efclient.sender.req." + proc, fname, iparm, msg, false);
}
/**
 * Creation date: (11/04/00 8:45:54 am)
 * @return boolean
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param msg eforward.util.Emsg
 * @param verbose boolean
 */
public boolean runEfsBin(String proc, String fname, String iparm, Emsg msg, boolean verbose) {
	return runJ("efserver.bin." + proc, fname, iparm, msg, verbose);
}
/**
 * @return boolean
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param msg eforward.util.Emsg
 */
public boolean runEfsSenderReq(String proc, String fname, String iparm, Emsg msg) {
	//runEfsbins
	//runJprocS( String rproc, String fname, String iparm)
	return runJ("efserver.sender.req." + proc, fname, iparm, msg, false);
}
/**
 * Insert the method's description here.
 * Creation date: (09/15/22 1:20:44 pm)
 * @return boolean
 * @param clsname java.lang.String
 * @param args java.lang.String
 */
public boolean runJ(String clsname, String args) {
	// note: args is csv format
	return runJar(clsname, null, args);
}
/**
 * @return boolean
 * @param clsname java.lang.String
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param eMsg eforward.util.Emsg
 * @param verbose boolean
 */
private boolean runJ(String clsname, String fname, String iparm, eforward.util.Emsg eMsg, boolean verbose) {
	return runJar(clsname, null, fname, iparm, eMsg, verbose);
}
/**
 * Insert the method's description here.
 * Creation date: (11/16/05 2:52:04 pm)
 * @return boolean
 * @param clsname java.lang.String
 * @param args java.lang.String[]
 */
public boolean runJ(String clsname, String[] args) {
	return runJar(clsname, null, args);
}
/**
 * Insert the method's description here.
 * Creation date: (04/02/18 3:00:02 pm)
 * @return boolean
 * @param clsname java.lang.String
 * @param args java.lang.String[]
 * @param fv eforward.util.FileVect
 */
public boolean runJ(String clsname, String[] args, FileVect fv) {
	String[] ar = new eforward.util.Copy().arrayCopy(args);
	boolean success = true;
	Class cls = null;
	Method m = null;
	Constructor ct = null;
	Object retobj = null;
	boolean zmt = false;
	Class[] partypes = null;
	Object[] arglist = null;
	try {
		cls = Class.forName(clsname);
		try {
			if (iMt != null) {
				partypes = new Class[3];
				partypes[0] = ar.getClass();
				partypes[1] = fv.getClass();
				partypes[2] = iMt.getClass();
				ct = cls.getConstructor(partypes);
				zmt = true;
			}
		} catch (Exception ze) {
			tX.text("Proc runJ iMt ze:" + ze.toString() + " " + clsname, true, null);
		}
		if (zmt) {
			arglist = new Object[3];
			arglist[0] = new eforward.util.Copy().arrayCopy(ar);
			arglist[1] = fv;
			arglist[2] = iMt;
			retobj = ct.newInstance(arglist);
		}
	} catch (Exception e) {
		tX.text("runJ zmt clsname cargs: " + e.toString(), true, null);
		success = false;
	}
	try {
		if (!zmt) {
			partypes = new Class[2];
			partypes[0] = ar.getClass();
			partypes[1] = fv.getClass();
			ct = cls.getConstructor(partypes);
			arglist = new Object[2];
			arglist[0] = new eforward.util.Copy().arrayCopy(ar);
			arglist[1] = fv;
			retobj = ct.newInstance(arglist);
		}
	} catch (Exception e) {
		tX.text("runJ clsname cargs fv: " + e.toString() + " " + clsname, true, null);
		success = false;
	}
	cls = null;
	m = null;
	ct = null;
	retobj = null;
	partypes = null;
	arglist = null;
	return success;
}
/**
 * Insert the method's description here.
 * Creation date: (09/15/22 12:36:59 pm)
 * @return boolean
 * @param clsname java.lang.String
 * @param jars java.lang.String
 * @param args java.lang.String
 */
public boolean runJar(String clsname, String jars, String args) {
	boolean success = true;
	Object main = null;
	Class c = null;
	boolean j = false;
	if (jars != null && jars.length() > 0) {
		j = true;
	}
	boolean zmt = false;
	Class[] partypes = null;
	Object[] arglist = null;
	String[] sa = new String[1];
	try {
		if (j) {
			eforward.util.JarLoader loader = new eforward.util.JarLoader(iUtil.getCsv(jars));
			main = loader.loadClass(clsname, true).newInstance();
			c = main.getClass();
		} else {
			c = Class.forName(clsname);
		}
		try {
			if (iMt != null) {
				partypes = new Class[2];
				partypes[0] = sa.getClass();
				partypes[1] = iMt.getClass();
				arglist = new Object[2];
				arglist[0] = iUtil.getCsv(args);
				arglist[1] = iMt;
				c.getConstructor(partypes).newInstance(arglist);
				zmt = true;
			}
		} catch (Exception ze) {
		}
	} catch (Exception e) {
		tX.text("runJar zmt clsname jars args iMt: " + e.toString(), true, null);
		success = false;
	}
	try {
		if (!zmt) {
			partypes = new Class[1];
			partypes[0] = sa.getClass();
			arglist = new Object[1];
			arglist[0] = iUtil.getCsv(args);
			c.getMethod("main", partypes).invoke(main, arglist);
		}
	} catch (Exception e) {
		tX.text("runJar clsname jars args: " + e.toString(), true, null);
		success = false;
	}
	main = null;
	c = null;
	partypes = null;
	arglist = null;
	return success;
}
/**
 * @return boolean
 * @param clsname java.lang.String
 * @param jars java.lang.String[]
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param eMsg eforward.util.Emsg
 * @param verbose boolean
 */
private boolean runJar(String clsname, String[] jars, String fname, String iparm, eforward.util.Emsg eMsg, boolean verbose) {
	boolean success = true;
	String fnm = fname;
	fname = fname.replace(' ', '_');
	fname = fname.concat(" ");
	fname = fname.concat(iparm);
	String[] sparm = iUtil.stringToArray(fname, ' ', '"', 0, false);
	sparm[0] = fnm;
	boolean zmt = false;
	Object main = null;
	Class cls = null;
	Constructor ct = null;
	Object retobj = null;
	boolean j = false;
	String[] ja = null;
	if (jars != null && jars.length > 0) {
		j = true;
		ja = new eforward.util.Copy().arrayCopy(jars);
	}
	Class[] partypes = null;
	Object[] arglist = null;
	try {
		if (j) {
			eforward.util.JarLoader loader = new eforward.util.JarLoader(ja);
			main = loader.loadClass(clsname, true).newInstance();
			cls = main.getClass();
		} else {
			cls = Class.forName(clsname);
		}
		try {
			if (iMt != null) {
				partypes = new Class[3];
				partypes[0] = sparm.getClass();
				partypes[1] = eMsg.getClass();
				partypes[2] = iMt.getClass();
				ct = cls.getConstructor(partypes);
				zmt = true;
			}
		} catch (Exception ze) {
		}
		if (zmt) {
			arglist = new Object[3];
			arglist[0] = new eforward.util.Copy().arrayCopy(sparm);
			arglist[1] = eMsg;
			arglist[2] = iMt;
			eMsg.setVerbose(verbose);
			retobj = ct.newInstance(arglist);
		}
	} catch (Exception e) {
		tX.text("runJar iMt " + e.toString(), true, null);
		success = false;
	}
	try {
		if (!zmt) {
			partypes = new Class[2];
			partypes[0] = sparm.getClass();
			partypes[1] = eMsg.getClass();
			ct = cls.getConstructor(partypes);
			arglist = new Object[2];
			arglist[0] = new eforward.util.Copy().arrayCopy(sparm);
			arglist[1] = eMsg;
			eMsg.setVerbose(verbose);
			retobj = ct.newInstance(arglist);
		}
	} catch (Exception e) {
		tX.text("runJar " + e.toString(), true, null);
		success = false;
	}
	sparm = null;
	main = null;
	cls = null;
	ct = null;
	retobj = null;
	ja = null;
	partypes = null;
	arglist = null;
	return success;
}
/**
 * Runs clsname from jars with args
 * new instance from constructor
 * clsname(String[] args, eforward.util.Mt iMt)
 * or
 * invoke from main
 * clsname.main(String[] args)
 *
 * Creation date: (12/08/02 11:37:56 am)
 * @return boolean
 * @param clsname java.lang.String
 * @param jars java.lang.String[]
 * @param args java.lang.String[]
 */
public boolean runJar(String clsname, String[] jars, String[] args) {
	return runJar(clsname, iUtil.setCsv(jars), iUtil.setCsv(args));
}
/**
 * Insert the method's description here.
 * Creation date: (11/04/00 8:45:54 am)
 * @return boolean
 * @param proc java.lang.String
 * @param jars java.lang.String[]
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param msg eforward.util.Emsg
 * @param verbose boolean
 */
public boolean runJarEfcBin(String proc, String[] jars, String fname, String iparm, Emsg msg, boolean verbose) {
	return runJar("efclient.bin." + proc, jars, fname, iparm, msg, verbose);
}
/**
 * Creation date: (11/04/00 8:45:54 am)
 * @return boolean
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param iparm java.lang.String
 * @param msg eforward.util.Emsg
 * @param verbose boolean
 */
public boolean runLclBin(String proc, String fname, String iparm, Emsg msg, boolean verbose) {
	return runJ("eforward.local.bin." + proc, fname, iparm, msg, verbose);
}
/**
 * Insert the method's description here.
 * Creation date: (09/15/22 1:06:59 pm)
 * @param clsname java.lang.String
 * @param method java.lang.String
 * @param jars java.lang.String
 * @param parms java.lang.String
 * @param success boolean[]
 */
public void runMethod(String clsname, String method, String jars, String parms, boolean[] success) {
	success[0]=true;
	success[1]=false;
	//
	Object main = null;
	Class cls = null;
	Constructor ct = null;
	Object retobj = null;
	boolean j = false;
	if (jars != null && jars.length() > 0) {
		j = true;
	}
	boolean zmt = false;
	Class[] argClass = null;
	Class[] partypes = null;
	Object[] arglist = null;
	Object[] clist = null;
	try {
		if (j) {
			eforward.util.JarLoader loader = new eforward.util.JarLoader(iUtil.getCsv(jars));
			main = loader.loadClass(clsname, true).newInstance();
			cls = main.getClass();
		} else {
			cls = Class.forName(clsname);
		}
		String[] pa = iUtil.getCsv(parms);
		argClass = new Class[pa.length];
		for (int x = 0; x < pa.length; x++) {
			argClass[x] = String.class;
		}
		arglist = new Object[pa.length];
		for (int x = 0; x < pa.length; x++) {
			arglist[x] = pa[x];
		}
		try {
			if (iMt != null) {
				partypes = new Class[1];
				partypes[0] = iMt.getClass();
				ct = cls.getConstructor(partypes);
				zmt = true;
			}
		} catch (Exception ze) {
		}
		if (zmt) {
			clist = new Object[1];
			clist[0] = iMt;
			retobj = ct.newInstance(clist);
			java.lang.reflect.Method mtd = cls.getMethod(method, argClass);
			Object ret = mtd.invoke(retobj, arglist);
			if (ret instanceof Boolean) {
				success[1] = ((Boolean) ret).booleanValue();
			}
		}
	} catch (Exception e) {
		success[0] = false;
		tX.text("runMethod zmt:" + e.toString(), true, null);
	}
	try {
		if (!zmt) {
			partypes = new Class[0];
			ct = cls.getConstructor(partypes);
			clist = new Object[0];
			retobj = ct.newInstance(clist);
			java.lang.reflect.Method mtd = cls.getMethod(method, argClass);
			Object ret = mtd.invoke(retobj, arglist);
			if (ret instanceof Boolean) {
				success[1] = ((Boolean) ret).booleanValue();
			}
		}
	} catch (Exception e) {
		success[0] = false;
		tX.text("runMethod:" + e.toString(), true, null);
	}
	main = null;
	cls = null;
	ct = null;
	retobj = null;
	argClass = null;
	partypes = null;
	arglist = null;
	clist = null;
}
/**
 * Insert the method's description here.
 * Creation date: (03/17/14 6:10:11 pm)
 * @return boolean[]
 * @param clsname java.lang.String
 * @param method java.lang.String
 * @param parms java.lang.String[]
 */
public boolean[] runMethod(String clsname, String method, String[] parms) {
	return new eforward.util.Copy().arrayCopy(runMethod(clsname, method, null, parms));
}
/**
 * Insert the method's description here.
 * Creation date: (03/17/14 3:34:25 pm)
 * @return boolean[]
 * @param clsname java.lang.String
 * @param method java.lang.String
 * @param jars java.lang.String[]
 * @param parms java.lang.String[]
 */
public boolean[] runMethod(String clsname, String method, String[] jars, String[] parms) {
	boolean[] success = {true, false};
	runMethod(clsname, method, iUtil.setCsv(jars), iUtil.setCsv(parms), success);
	return new eforward.util.Copy().arrayCopy(success);
}
/**
 * Insert the method's description here.
 * Creation date: (01/13/19 4:02:00 pm)
 * @return eforward.util.Proc$X
 * @param clsname java.lang.String
 * @param jars java.lang.String[]
 * @param args java.lang.String[]
 * @param run java.lang.String
 * @param end java.lang.String
 */
public ProcX runMtMethod(String clsname, String[] jars, String[] args, String run, String end) {
	ProcX r = null;
	try {
//System.out.println("runMtMethod jars:"+clsname+":"+new eforward.util.Util().appnd(jars,"^"));		
		r = new ProcX(clsname, jars, args, run, end, iMt);
		String[] parms = {""};
		iMt.add((Object) r, "run", "end", parms);
	} catch (Exception e) {
		tX.text("runMtMethod:" + e.toString(), true, null);
	}
	return r;
}
/**
 * Insert the method's description here.
 * Creation date: (12/30/15 9:10:27 am)
 * @param command java.lang.String
 * @param lv eforward.util.ListVect
 * @param destroy boolean
 * @param secs int
 */
public void runRcmd(String command, ListVect lv, boolean destroy, int secs) {
	runRcmd(command, null, lv, destroy, secs);
}
/**
 * Insert the method's description here.
 * Creation date: (01/01/16 4:49:34 pm)
 * @param command java.lang.String
 * @param envar java.lang.String[]
 * @param lv eforward.util.ListVect
 * @param destroy boolean
 * @param secs int
 */
public void runRcmd(String command, String[] envar, ListVect lv, boolean destroy, int secs) {
	boolean verbose = true;
	//String[] cmd = new String[0];
	//String[] lnx = {"/bin/sh", "-c", command};
	//String[] os2 = {"cmd", "/C", command};
	//String[] win = {"cmd", "/C", command};
	String[] cmd = new String[3];
	if (os < 0)
		os = getO();
	if (os == 1) {
		//cmd = new eforward.util.Copy().arrayCopy(lnx);
		cmd[0] = "/bin/sh";
		cmd[1] = "-c";
		cmd[2] = command;
	} else
		if (os == 2) {
			//cmd = new eforward.util.Copy().arrayCopy(os2);
			cmd[0] = "cmd";
			cmd[1] = "/C";
			cmd[2] = command;
		} else {
			//cmd = new eforward.util.Copy().arrayCopy(win);
			cmd[0] = "cmd";
			cmd[1] = "/C";
			cmd[2] = command;
		}
	Process p = null;
	boolean cont = true;
	java.io.InputStream ip = null;
	java.io.InputStream ep = null;
	java.io.BufferedInputStream bi = null;
	java.io.BufferedInputStream be = null;
	java.io.ByteArrayOutputStream bo = null;
	try {
		try {
			if (envar == null) {
				p = Runtime.getRuntime().exec(new eforward.util.Copy().arrayCopy(cmd));
			} else {
				p = Runtime.getRuntime().exec(new eforward.util.Copy().arrayCopy(cmd), new eforward.util.Copy().arrayCopy(envar));
			}
		} catch (Exception eee) {
			cont = false;
			p = null;
		}
		//////////////////////
		if (cont) {
			boolean file = false;
			boolean list = false;
			boolean j3 = false;
			FileVect fv = null;
			String version = null;
			boolean stop = false;
			////
			version = System.getProperty("java.version");
			if (version.startsWith("1.3") || version.startsWith("1.1"))
				j3 = true;
			if (lv != null)
				list = true;
			if (verbose) {
				bo = new java.io.ByteArrayOutputStream();
			}
			try {
				ip = (java.io.InputStream) p.getInputStream();
				ep = (java.io.InputStream) p.getErrorStream();
				if (!j3) {
					bi = new java.io.BufferedInputStream(ip);
					be = new java.io.BufferedInputStream(ep);
				}
			} catch (Exception e) {
				stop = true;
			}
			////			
			if (verbose) {
				bo = new java.io.ByteArrayOutputStream();
			}
			try {
				ip = (java.io.InputStream) p.getInputStream();
				ep = (java.io.InputStream) p.getErrorStream();
				if (!j3) {
					bi = new java.io.BufferedInputStream(ip);
					be = new java.io.BufferedInputStream(ep);
				}
				eforward.util.Io iO = new eforward.util.Io();
				int a = 1, b = 0, c = 0, z = 0;
				if (secs < 5)
					secs = 5;
				int timeout = secs * 19;
				if (verbose) {
					byte[] odat = ("Proc.runRcmd start java version " + version + " " + new java.util.Date().toString()).getBytes();
					if (list) {
						lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
					} else
						if (file) {
							fv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
						} else {
							tX.text("runRcmd A:" + new String(odat), true, null);
						}
				}
				Thread.sleep(50);
				if (!j3) {
					try {
						boolean m = true;
						int k = 0;
						while (m) {
							boolean set = false;
							a = bi.available();
							if (a > 0) {
								set = true;
								k = 0;
								a = bi.read();
								if (verbose)
									bo.write(a);
								z++;
								if (a == 10)
									b = 256;
								if (verbose && (b++ > 255)) {
									b = 0;
									if (z > 1000) {
										z = 0;
										Thread.sleep(50);
									}
									byte[] odat = bo.toByteArray();
									if (odat != null) {
										odat = iO.trimEol(new eforward.util.Copy().arrayCopy(odat));
										if (list) {
											lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
										} else
											if (file) {
												fv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
											} else {
												tX.text("runRcmd B:" + new String(odat), true, null);
											}
									}
									bo.reset();
									c = 0;
								}
							}
							a = be.available();
							if (a > 0) {
								set = true;
								k = 0;
								a = be.read();
								if (verbose)
									bo.write(a);
								z++;
								if (a == 10)
									b = 256;
								if (verbose && (b++ > 255)) {
									b = 0;
									if (z > 1000) {
										z = 0;
										Thread.sleep(50);
									}
									byte[] odat = bo.toByteArray();
									if (odat != null) {
										odat = iO.trimEol(new eforward.util.Copy().arrayCopy(odat));
										if (list) {
											lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
										} else
											if (file) {
												fv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
											} else {
												tX.text("runRcmd B:" + new String(odat), true, null);
											}
									}
									bo.reset();
									c = 0;
								}
							}
							if (!set) {
								try {
									int r = p.exitValue();
									stop = true;
								} catch (Exception re) {
								}
								if (!stop) {
									k++;
									if (k > timeout)
										m = false;
									Thread.sleep(51);
									if (verbose && bo.size() > 0 && c++ > 20) {
										byte[] odat = bo.toByteArray();
										if (odat != null) {
											odat = iO.trimEol(new eforward.util.Copy().arrayCopy(odat));
											if (list) {
												lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
											} else
												if (file) {
													fv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
												} else {
													tX.text("runRcmd C:" + new String(odat), true, null);
												}
										}
										bo.reset();
										c = 0;
									}
								}
							}
							a = bi.available();
							int a2 = be.available();
							if (a < 1 && a2 < 1 && stop) {
								Thread.sleep(30);
								a = bi.available();
								a2 = be.available();
								if (a < 1 && a2 < 1)
									m = false;
							}
						}
					} catch (Exception e) {
						tX.text("Proc.runRcmd run e1:" + e.toString(), true, null);
					}
				}
				if (j3) {
					try {
						while (!stop && ((a = ip.read()) > -1)) {
							bo.write(a);
						}
						java.util.Vector v = new java.util.Vector();
						new eforward.util.Io().readInput(bo.toByteArray(), v);
						for (b = 0; b < v.size(); b++) {
							String s = (String) v.elementAt(b);
							s = iO.trimEol(s);
							byte[] odat = s.getBytes();
							if (list) {
								lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
							} else
								if (file) {
									fv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
								} else {
									tX.text("runRcmd D:" + s, true, null);
								}
						}
						bo.reset();
					} catch (Exception e) {
						tX.text("Proc$O.runRcmd run e2:" + e.toString(), true, null);
					}
				}
				try {
					if (verbose && bo.size() > 0) {
						byte[] odat = bo.toByteArray();
						if (odat != null) {
							if (list) {
								lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
							} else
								if (file) {
									fv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
								} else {
									tX.text("runRcmd E:" + new String(odat), true, null);
								}
						}
					}
					if (verbose) {
						byte[] odat2 = ("Proc.runRcmd end " + new java.util.Date().toString()).getBytes();
						if (list) {
							lv.write(new eforward.util.Copy().arrayCopy(odat2), 0, odat2.length, 0);
						} else
							if (file) {
								fv.write(new eforward.util.Copy().arrayCopy(odat2), 0, odat2.length, 0);
							} else {
								tX.text("runRcmd F:" + new String(odat2), true, null);
							}
					}
				} catch (Exception e) {
					tX.text("PrunRcmd e3:" + e.toString(), true, null);
				}
			} catch (Exception ex) {
				tX.text("runRcmd ex:" + ex.toString(), true, null);
			}
		}
	} catch (Exception e) {
		destroy = true;
		tX.text("runRcmd G:" + e.toString(), verbose, null);
	}
	try {
		if (bi != null)
			bi.close();
	} catch (Exception e) {
	}
	try {
		if (be != null)
			be.close();
	} catch (Exception e) {
	}
	try {
		if (ip != null)
			ip.close();
	} catch (Exception e) {
	}
	try {
		if (ep != null)
			ep.close();
	} catch (Exception e) {
	}
	try {
		if (bo != null)
			bo.close();
	} catch (Exception e) {
	}
	if (destroy && p != null) {
		try {
			p.destroy();
		} catch (Exception e) {
		}
	}
	//System.gc();
}
/**
 * @param proc java.lang.String
 * @param fname java.lang.String
*/
public void runRproc(String proc, String fname) {
//System.out.println("runRproc F: " + proc);
	runRproc(proc, fname, "");
	return;
}
/**
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param param java.lang.String
*/
public void runRproc(String proc, String fname, String param) {
//System.out.println("runRproc G: " + proc);
	runRproc(proc, fname, param, null);
}
/**
 * Insert the method's description here.
 * Creation date: (11-06-09 7:13:53 pm)
 * @param proc java.lang.String
 * @param fname java.lang.String
 * @param param java.lang.String
 * @param env java.lang.String[]
 */
public void runRproc(String proc, String fname, String param, String[] env) {
//System.out.println("runRproc H: " + proc);
	proc = proc + " " + param;
	proc = setParamFileSub(proc, fname);
	String[] cmd = iUtil.stringToArray(proc, ' ', '"', 0, false);
	runRproc(new eforward.util.Copy().arrayCopy(cmd), false, env, null, false, 900, null, false);
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (08/19/04 4:38:19 pm)
 * @param proc java.lang.String
 * @param verbose boolean
 */
public void runRproc(String proc, boolean verbose) {
//System.out.println("runRproc E: " + proc);
	String[] cmd = {proc};
	runRproc(cmd, verbose);
}
/**
 * Insert the method's description here.
 * Creation date: (12/13/05 11:01:00 am)
 * @param proc java.lang.String[]
 * @param verbose boolean
 */
public void runRproc(String[] proc, boolean verbose) {
//System.out.println("runRproc A: " + new eforward.util.Util().appnd(proc, "^"));
	runRproc(new eforward.util.Copy().arrayCopy(proc), verbose, null, null, false, 900, null, false);
}
/**
 * Insert the method's description here.
 * Creation date: (02/15/20 8:22:04 am)
 * @param proc java.lang.String[]
 * @param verbose boolean
 * @param iv java.util.Vector
 */
public void runRproc(String[] proc, boolean verbose, java.util.Vector iv) {
//System.out.println("runRproc D: " + new eforward.util.Util().appnd(proc, "^"));
	runRproc(proc, verbose, null, null, false, 900, iv, false);
}
/**
 * Insert the method's description here.
 * Creation date: (12/30/15 10:20:25 am)
 * @param proc java.lang.String[]
 * @param verbose boolean
 * @param env java.lang.String[]
 * @param fv eforward.util.ListVect
 */
public void runRproc(String[] proc, boolean verbose, String[] env, ListVect fv) {
//System.out.println("runRproc B: " + new eforward.util.Util().appnd(proc, "^"));
	runRproc(proc, verbose, env, fv, true, 60, null, false);
}
/**
 * Insert the method's description here.
 * Creation date: (08/13/22 9:49:56 am)
 * @param proc java.lang.String[]
 * @param verbose boolean
 * @param envar java.lang.String[]
 * @param lv eforward.util.ListVect
 * @param destroy boolean
 * @param secs int
 * @param iv java.util.Vector
 */
public void runRproc(String[] proc, boolean verbose, String[] envar, ListVect lv, boolean destroy, int secs, java.util.Vector iv) {
	runRproc(proc, verbose, envar, lv, destroy, secs, iv, true);
}
/**
 * Insert the method's description here.
 * Creation date: (08/13/22 9:15:45 am)
 * @param proc java.lang.String[]
 * @param verbose boolean
 * @param envar java.lang.String[]
 * @param lv eforward.util.ListVect
 * @param destroy boolean
 * @param secs int
 * @param iv java.util.Vector
 * @param array boolean
 */
public void runRproc(String[] proc, boolean verbose, String[] envar, ListVect lv, boolean destroy, int secs, java.util.Vector iv, boolean array) {
	String[] cmd = new String[proc.length];
	for (int x = 0; x < proc.length; x++) {
		cmd[x] = proc[x];
	}
	String[] evr = null;
	if (envar != null) {
		evr = new String[envar.length];
		for (int x = 0; x < envar.length; x++) {
			evr[x] = envar[x];
		}
	}
	java.io.InputStream ip = null;
	java.io.BufferedInputStream bi = null;
	java.io.ByteArrayOutputStream bo = null;
	Process p = null;
	boolean cont = true;
	try {
		try {
			if (evr == null) {
				p = Runtime.getRuntime().exec(cmd);
			} else {
				p = Runtime.getRuntime().exec(cmd, evr);
			}
		} catch (Exception eee) {
			cont = false;
			p = null;
		}
		//////////////////////
		if (cont) {
			boolean file = false;
			boolean list = (iv != null) ? true : false;
			boolean j3 = false;
			String version = null;
			boolean stop = false;
			////
			version = System.getProperty("java.version");
			if (version.startsWith("1.3") || version.startsWith("1.1"))
				j3 = true;
			if (lv != null)
				file = true;
			if (verbose) {
				bo = new java.io.ByteArrayOutputStream();
			}
			try {
				ip = (java.io.InputStream) p.getInputStream();
				if (!j3)
					bi = new java.io.BufferedInputStream(ip);
			} catch (Exception e) {
				stop = true;
			}
			////			
			if (verbose) {
				bo = new java.io.ByteArrayOutputStream();
			}
			try {
				ip = (java.io.InputStream) p.getInputStream();
				if (!j3)
					bi = new java.io.BufferedInputStream(ip);
				eforward.util.Io iO = new eforward.util.Io();
				int a = 1, b = 0, c = 0, z = 0;
				if (secs < 5)
					secs = 5;
				int timeout = secs * 19;
				if (verbose) {
					byte[] odat = ("Proc.runRproc start java version " + version + " " + new java.util.Date().toString()).getBytes();
					if (list) {
						if (!array) {
							iv.addElement(new String(odat));
						} else {
							iv.addElement(new eforward.util.Copy().arrayCopy(odat));
						}
					} else
						if (file) {
							lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
						} else {
							tX.text("runRproc A:" + new String(odat), true, null);
						}
				}
				Thread.sleep(50);
				//Thread.sleep(200);
				if (!j3) {
					try {
						boolean m = true;
						int k = 0;
						while (m) {
							a = bi.available();
							if (a > 0) {
								k = 0;
								a = bi.read();
								if (verbose)
									bo.write(a);
								z++;
								if (a == 10)
									b = 256;
								if (verbose && (b++ > 255)) {
									b = 0;
									if (z > 1000) {
										z = 0;
										Thread.sleep(50);
									}
									byte[] odat = bo.toByteArray();
									if (odat != null) {
										odat = iO.trimEol(new eforward.util.Copy().arrayCopy(odat));
										if (list) {
											if (!array) {
												iv.addElement(new String(odat));
											} else {
												iv.addElement(new eforward.util.Copy().arrayCopy(odat));
											}
										} else
											if (file) {
												lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
											} else {
												tX.text("runRproc B:" + new String(odat), true, null);
											}
									}
									bo.reset();
									c = 0;
								}
							} else {
								try {
									int r = p.exitValue();
									stop = true;
								} catch (Exception re) {
								}
								if (!stop) {
									k++;
									if (k > timeout)
										m = false;
									Thread.sleep(51);
									if (verbose && bo.size() > 0 && c++ > 20) {
										byte[] odat = bo.toByteArray();
										if (odat != null) {
											odat = iO.trimEol(new eforward.util.Copy().arrayCopy(odat));
											if (list) {
												if (!array) {
													iv.addElement(new String(odat));
												} else {
													iv.addElement(new eforward.util.Copy().arrayCopy(odat));
												}
											} else
												if (file) {
													lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
												} else {
													tX.text("runRproc C:" + new String(odat), true, null);
												}
										}
										bo.reset();
										c = 0;
									}
								}
							}
							a = bi.available();
							if (a < 1 && stop) {
								Thread.sleep(30);
								a = bi.available();
								if (a < 1)
									m = false;
							}
						}
					} catch (Exception e) {
						tX.text("Proc.runRproc run e1:" + e.toString(), true, null);
					}
				}
				if (j3) {
					Thread.sleep(100);
					try {
						while (!stop && ((a = ip.read()) > -1)) {
							bo.write(a);
						}
						java.util.Vector v = new java.util.Vector();
						new eforward.util.Io().readInput(bo.toByteArray(), v);
						for (b = 0; b < v.size(); b++) {
							String s = (String) v.elementAt(b);
							s = iO.trimEol(s);
							byte[] odat = s.getBytes();
							if (list) {
								if (!array) {
									iv.addElement(new String(odat));
								} else {
									iv.addElement(new eforward.util.Copy().arrayCopy(odat));
								}
							} else
								if (file) {
									lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
								} else {
									tX.text("runRproc D:" + s, true, null);
								}
						}
						bo.reset();
					} catch (Exception e) {
						tX.text("Proc$O.runRproc run e2:" + e.toString(), true, null);
					}
				}
				try {
					if (verbose && bo.size() > 0) {
						byte[] odat = bo.toByteArray();
						if (odat != null) {
							if (list) {
								if (!array) {
									iv.addElement(new String(odat));
								} else {
									iv.addElement(new eforward.util.Copy().arrayCopy(odat));
								}
							} else
								if (file) {
									lv.write(new eforward.util.Copy().arrayCopy(odat), 0, odat.length, 0);
								} else {
									tX.text("runRproc E:" + new String(odat), true, null);
								}
						}
					}
					if (verbose) {
						byte[] odat2 = ("Proc.runRproc end " + new java.util.Date().toString()).getBytes();
						if (list) {
							if (!array) {
								iv.addElement(new String(odat2));
							} else {
								iv.addElement(new eforward.util.Copy().arrayCopy(odat2));
							}
						} else
							if (file) {
								lv.write(new eforward.util.Copy().arrayCopy(odat2), 0, odat2.length, 0);
							} else {
								tX.text("runRproc F:" + new String(odat2), true, null);
							}
					}
				} catch (Exception e) {
					tX.text("PrunRproc e3:" + e.toString(), true, null);
				}
				Thread.sleep(100);
			} catch (Exception ex) {
				tX.text("runRproc ex:" + ex.toString(), true, null);
			}
		}
	} catch (Exception e) {
		destroy = true;
		tX.text("runRproc G:" + e.toString(), verbose, null);
	}
	try {
		if (bi != null)
			bi.close();
	} catch (Exception e) {
	}
	try {
		if (ip != null)
			ip.close();
	} catch (Exception e) {
	}
	try {
		if (bo != null)
			bo.close();
	} catch (Exception e) {
	}
	if (destroy && p != null) {
		try {
			p.destroy();
		} catch (Exception e) {
		}
	}
}
/**
 * @return java.lang.String
 * @param param java.lang.String
 * @param filename java.lang.String
 */
public String setParamFileSub(String param, String filename) {
	String start, end;
	int st = 0, en = 0, len = 0;
	start = null;
	end = null;
	en = param.indexOf("FILE");
	if (en > -1) {
		start = param.substring(0, en);
		len = param.length();
		end = param.substring((en + 4), len);
		param = start + filename + end;
	} else
		param = param + " " + filename;
	return param;
}
}
